#!/usr/bin/python
import XenAPI
from pprint import pprint
import os

mastersrvxen = "192.168.149.202"
password_xen = "calimero"

session = XenAPI.Session('https://'+mastersrvxen)
try:
  session.login_with_password('root',password_xen)
except XenAPI.Failure, error:
  msg,ip = error.details

  if msg == 'HOST_IS_SLAVE':
     mastersrvxen = ip
     session = XenAPI.Session('https://'+mastersrvxen)
     session.login_with_password('root',password_xen)
       
 

vbdlist = session.xenapi.VBD.get_all()
for i in vbdlist:
	typevdb = session.xenapi.VBD.get_type(i)
	if typevdb == "CD":
		uuidvdb = session.xenapi.VBD.get_uuid(i)
		ejectvdb = "/opt/xensource/bin/xe --nossl -s "+mastersrvxen+" -pwf /etc/tis/nut/credential.txt vbd-eject uuid="+uuidvdb
		os.system(ejectvdb)

srlist = session.xenapi.SR.get_all()
for x in srlist:
	typesr = session.xenapi.SR.get_type(x)
	if typesr == "iso":
		pbdlist = session.xenapi.SR.get_PBDs(x)
		for n in pbdlist:
			srpbduuid = session.xenapi.PBD.get_uuid(n)
			unplugsr = "/opt/xensource/bin/xe --nossl -s "+mastersrvxen+" -pwf /etc/tis/nut/credential.txt pbd-unplug uuid="+srpbduuid
			os.system(unplugsr)

vmlist = session.xenapi.VM.get_all()
for t in vmlist:
	statusvm = session.xenapi.VM.get_power_state(t)
	if statusvm == "Running":
		pprint(t)
		vmname = session.xenapi.VM.get_name_label(t)
		print vmname
		shutdownvm = "/opt/xensource/bin/xe --nossl -s "+mastersrvxen+" -pwf /etc/tis/nut/credential.txt vm-shutdown vm="+vmname
		os.system(shutdownvm)

poollist = session.xenapi.pool.get_all()
for i in poollist:
	master = session.xenapi.pool.get_master(i)

hostlist = session.xenapi.host.get_all()
for u in hostlist:
	if u != master:
		slave = session.xenapi.host.get_name_label(u)
		disableslave ="/opt/xensource/bin/xe --nossl -s " +mastersrvxen+" -pwf /etc/tis/nut/credential.txt host-disable host="+slave
		shutdownslave ="/opt/xensource/bin/xe --nossl -s " +mastersrvxen+" -pwf /etc/tis/nut/credential.txt host-shutdown host="+slave
		os.system(disableslave)
		os.system(shutdownslave)
mastername =  session.xenapi.host.get_name_label(master)
disablemaster = "/opt/xensource/bin/xe --nossl -s "+mastersrvxen+" -pwf /etc/tis/nut/credential.txt host-disable host="+mastername
shutdownmaster ="/opt/xensource/bin/xe --nossl -s "+mastersrvxen+" -pwf /etc/tis/nut/credential.txt host-shutdown host="+mastername
os.system(disablemaster)
os.system(shutdownmaster)
session.logout()
